;----------------------------------------------
;    (LOWD)x(CALCW)
;      LOWD
;      CALCW
;     MIDDLED,   
;: LOWD, CALCW
;: HIGHD, LOWD, MIDDLED
;: 
;: HIGHD, LOWD
;----------------------------------------------
MUL_1x1
	clrwdt			;   .
	clrf	HIGHD		;  HIGHD (  )
	movlw	.0 
	xorwf	LOWD,W		;  ""       
	pagesel	mul_1x1_e	; LOWD:      
	btfsc	STATUS,Z	;  LOWD
	goto	mul_1x1_e	;   LOWD  :    
	movlw	.0		;   LOWD   :   
	xorwf	CALCW,W		;     CALCW
	pagesel	mul_1x1_3
	btfsc	STATUS,Z	;
	goto	mul_1x1_3	;   CALCW  :    mul_1x1_3
	movf	LOWD,W		;  CALCW   :    LOWD
	movwf	MIDDLED		;  MIDDLED,      
mul_1x1_1
	pagesel	mul_1x1_2
	decfsz	CALCW,F         ; ( )  CALCW
	goto	mul_1x1_2	; CALCW   :    mul_1x1_2       
	pagesel	mul_1x1_e
	goto	mul_1x1_e	; CALCW  :   
mul_1x1_2
	movf	MIDDLED,W	;    MIDDLED   
	addwf	LOWD,F		;  LOWD
	btfsc	STATUS,C	;   LOWD
	incf	HIGHD,F		; LOWD:   HIGHD
	pagesel	mul_1x1_1
	goto	mul_1x1_1	;   mul_1x1_1
mul_1x1_3
	clrf	LOWD		;  LOWD (  )
mul_1x1_e
	return			;  
;----------------------------------------------
;       (HIGHD, LOWD):(MIDDLED)
;      HIGHD, LOWD
;      MIDDLED
;    rezLH, rezLL,     
;   ,      
;: HIGHD, LOWD, MIDDLED
;: rezLH, rezLL, LOWD, HIGHD
;: 
;: rezLH, rezLL
;----------------------------------------------
DIV_2x1
	clrwdt			;   .
	clrf	rezLL		;  rezLL, rezLH (  )
	clrf	rezLH		;
	movlw	.0		;       MIDDLED
	xorwf	MIDDLED,W	;(   )
	pagesel	div_2x1_e
	btfsc	STATUS,Z	;
	goto	div_2x1_e	;   MIDDLED  :   
div_2x1_1
	movf	MIDDLED,W	;  MIDDLED   :      
	subwf	LOWD,F		;MIDDLED     HIGHD, LOWD:    
	pagesel	div_2x1_2	;   
	btfsc	STATUS,C
	goto	div_2x1_2	;      
	movlw	.1		;     
	subwf	HIGHD,F		;   div_2x1_2
	pagesel	div_2x1_e
	btfss	STATUS,C	;
	goto	div_2x1_e
div_2x1_2
	pagesel	div_2x1_1
	incfsz	rezLL,F		; rezLL          
	goto	div_2x1_1	;  rezLL:    div_2x1_1 
	incf	rezLH,F		; rezLL:   rezLH 
	pagesel	div_2x1_1
	goto	div_2x1_1	;   div_2x1_1   
div_2x1_e
	return

;----------------------------------------------
;    2 
;: W
;: W, HIGHD, LOWD	
;: 
;: HIGHD, LOWD
;----------------------------------------------
DIGIT_CALC_Y
	clrwdt			;   .
	movwf	HIGHD		;  W   HIGHD	
	andlw	B'00001111'	;   
	movwf	LOWD		;     LOWD	
	swapf	HIGHD,W		;    HIGHD    W
	andlw	B'00001111'	;   
	movwf	HIGHD		;     HIGHD	
	return
;----------------------------------------------
;  , ,     2 
;: W
;: W, HIGHD, LOWD	
;: 
;: HIGHD, LOWD
;----------------------------------------------
DIGIT_CALC_SMD
	clrwdt			;   .
	movwf	HIGHD		;  W   HIGHD	
	andlw	B'00001111'	;   
	movwf	LOWD		;     LOWD	
	swapf	HIGHD,W		;    HIGHD    W
	andlw	B'00000111'	;   5 
	movwf	HIGHD		;     HIGHD	
	return
;----------------------------------------------
;    2 
;: W
;: W, HIGHD, LOWD	
;: 
;: HIGHD, LOWD
;----------------------------------------------
DIGIT_CALC_H
	clrwdt			;   .
	movwf	HIGHD		;  W   HIGHD	
	andlw	B'00001111'	;   
	movwf	LOWD		;     LOWD	
	swapf	HIGHD,W		;    HIGHD    W
	andlw	B'00000011'	;   6 
	movwf	HIGHD		;     HIGHD	
	return
;----------------------------------------------
;    , 
;  ,   
;    
;: W
;: W, LOWD, MIDDLED, HIGHD
;: 
;: LOWD, MIDDLED, HIGHD
;----------------------------------------------
DIGIT_CALC_B	
	clrwdt			;   .
	clrf	HIGHD		;
	clrf	MIDDLED		;
	clrf	LOWD		;
;--   -------------------
	movwf	LOWD		;    LOWD
digit_calc_b_1
	addlw	-0Ah
	pagesel	digit_calc_b_2
	btfss	STATUS,C	;  ,
	goto	digit_calc_b_2	;   
	movwf	LOWD		;   
	incf	MIDDLED,f	;  + 1
	pagesel	digit_calc_b_1
	goto	digit_calc_b_1	;  
digit_calc_b_2
	movf	MIDDLED,W
	addlw	-0Ah
	pagesel	digit_calc_b_e
	btfss	STATUS,C	;  ,
	goto	digit_calc_b_e	;    
	movwf	MIDDLED		;    
	incf	HIGHD,f		;  + 1
	pagesel	digit_calc_b_2
	goto	digit_calc_b_2	;  
digit_calc_b_e
	return			;   
;----------------------------------------------
;          
;: W
;: W, 
;: 
;: W
;----------------------------------------------
SEVENSEG
	clrwdt			;   .
	movwf	CALCW		;     CALCW
	pagesel	sevenseg2
	decfsz	CALCW,f		;    1
	goto	sevenseg2	;  0, 
	movlw	.6		; 0,  1
	pagesel	sevensege
	goto	sevensege
sevenseg2
	pagesel	sevenseg3
	decfsz	CALCW,f		;    1
	goto	sevenseg3	;  0, 
	movlw	.91		; 0,  2
	pagesel	sevensege
	goto	sevensege
sevenseg3
	pagesel	sevenseg4
	decfsz	CALCW,f		;    1
	goto	sevenseg4	;  0, 
	movlw	.79		; 0,  3
	pagesel	sevensege
	goto	sevensege
sevenseg4
	pagesel	sevenseg5
	decfsz	CALCW,f		;    1
	goto	sevenseg5	;  0, 
	movlw	.102		; 0,  4
	pagesel	sevensege
	goto	sevensege
sevenseg5
	pagesel	sevenseg6
	decfsz	CALCW,f		;    1
	goto	sevenseg6	;  0, 
	movlw	.109		; 0,  5
	pagesel	sevensege
	goto	sevensege
sevenseg6
	pagesel	sevenseg7
	decfsz	CALCW,f		;    1
	goto	sevenseg7	;  0, 
	movlw	.125		; 0,  6
	pagesel	sevensege
	goto	sevensege
sevenseg7
	pagesel	sevenseg8
	decfsz	CALCW,f		;    1
	goto	sevenseg8	;  0, 
	movlw	.7		; 0,  7
	pagesel	sevensege
	goto	sevensege
sevenseg8
	pagesel	sevenseg9
	decfsz	CALCW,f		;    1
	goto	sevenseg9	;  0, 
	movlw	.127		; 0,  8
	pagesel	sevensege
	goto	sevensege
sevenseg9
	pagesel	sevenseg0
	decfsz	CALCW,f		;    1
	goto	sevenseg0	;  0, 
	movlw	.111		; 0,  9
	pagesel	sevensege
	goto	sevensege
sevenseg0
	movlw	.63		;   0
sevensege
	return			;  