;    

;----------------------------------------------
;    
;: SETTINGS2, Speed
;: DIGIT1, SETTINGS2
;: DOUT_4D, DISPLAY_2
;: 
;----------------------------------------------
DOUT_SPEED
	clrwdt				;   .
	pagesel	dout_speed_e
	btfss	SETTINGS2,5		;      
	goto	dout_speed_e		; SETTINGS2,5 = 0,  
;     
	movf	Speed,W
	pagesel	DOUT_4D	
	call	DOUT_4D	
	movlw	B'01011000' 		;  "c"
	movwf	DIGIT1			;   1
	pagesel	DISPLAY_2		;   
	call	DISPLAY_2
	bcf	SETTINGS2,5		;      
dout_speed_e
	return
;----------------------------------------------
;   /
;: SETTINGS
;: 
;: DT_OUT, DISPLAY_3
;: 
;----------------------------------------------
DOUT_DT
	clrwdt			;   .
	pagesel	dout_dt_e
	btfss	SETTINGS,0	;   
	goto	dout_dt_e		; SETTINGS,0 = 0,   
;  /
	pagesel	DT_OUT			;        
	call	DT_OUT			;     
	pagesel	DISPLAY_3		;   
	call	DISPLAY_3
dout_dt_e
	return
;----------------------------------------------
;   
;: SETTINGS, IZM_UR
;: DIGIT3, LOWD, CALCW, MIDDLED
;: MUL_1x1, DIV_2x1, DOUT_4D, DISPLAY_1
;: 
;----------------------------------------------
DOUT_U
	clrwdt			;   .
	pagesel	dout_u_e
	btfss	SETTINGS,0	;   
	goto	dout_u_e	; SETTINGS,0 = 0,   
	pagesel	dout_u_b
	btfsc	BUTTONS,3	;    
	goto	dout_u_b	; BUTTONS,3 = 1,  
	pagesel	dout_u_e12
	btfss	BUTTONS,4	;    
	goto	dout_u_e12	; BUTTONS,4 = 0,    
	pagesel	dout_u_b
	btfsc	BUTTONS,4	;    
	goto	dout_u_b	; BUTTONS,4 = 1,   
	pagesel	dout_u_e
	btfss	BUTTONS,3	;    
	goto	dout_u_e	; BUTTONS,3 = 0,   
;  
dout_u_b
	movf	IZM_UR,W	;  
	movwf	LOWD
	movlw	UMUL_CONST	;  ,    
	movwf	CALCW
	pagesel	MUL_1x1	
	call	MUL_1x1		;     UMUL_CONST
	movlw	UDIV_CONST	;  ,    
	movwf	MIDDLED
	pagesel	DIV_2x1	
	call	DIV_2x1		;       UDIV_CONST
	movf	rezLL,W		;   
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	bsf	DIGIT3,7	;   
	pagesel	DISPLAY_1	;   
	call	DISPLAY_1
	pagesel	dout_u_e
	goto	dout_u_e
dout_u_e12
	pagesel	DOFF_12		
	call	DOFF_12
dout_u_e
	return
;----------------------------------------------
;    
;: SETTINGS, IZM_PR
;: 
;: DOUT_4D, DISPLAY_2
;: 
;----------------------------------------------
DOUT_O
	clrwdt			;   .
	pagesel	dout_o_e
	btfss	SETTINGS,0	;   
	goto	dout_o_e	; SETTINGS,0 = 0,   
	pagesel	dout_o_e
	btfsc	BUTTONS,3	;    
	goto	dout_o_e	; BUTTONS,3 = 1,  
	pagesel	dout_o_b
	btfsc	BUTTONS,4	;    
	goto	dout_o_b	; BUTTONS,4 = 1,   
	pagesel	dout_o_e
	goto	dout_o_e
;    	
dout_o_b
	movf	IZM_PR,w	;     W
	sublw	.255		; 
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	movlw	B'01011100' 	;  ""
	movwf	DIGIT1		;   1
	pagesel	DISPLAY_2	;   
	call	DISPLAY_2
dout_o_e
	return
;----------------------------------------------
;  
;: 
;: 
;: DISPLAY_1, DISPLAY_2, DISPLAY_3
;: 
;----------------------------------------------
DOFF_ALL
	clrwdt			;   .
	movlw  	.0
	movwf  	DIGIT4
	movlw	.0
	movwf  	DIGIT3
	movlw	.0  
	movwf  	DIGIT2
	movlw  	.0 
	movwf  	DIGIT1
	pagesel	DISPLAY_1	;  
	call	DISPLAY_1
	pagesel	DISPLAY_2	;  
	call	DISPLAY_2
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	return
;----------------------------------------------
;  
;: 
;: 
;: DISPLAY_1, DISPLAY_2
;: 
;----------------------------------------------
DOFF_12
	clrwdt			;   .
	movlw  	.0
	movwf  	DIGIT4
	movlw	.0
	movwf  	DIGIT3
	movlw	.0  
	movwf  	DIGIT2
	movlw  	.0 
	movwf  	DIGIT1
	pagesel	DISPLAY_1	;  
	call	DISPLAY_1
	pagesel	DISPLAY_2	;  
	call	DISPLAY_2
	return
;----------------------------------------------
;      
;: W
;: W, HIGHD, MIDDLED, LOWD
;: DIGIT_CALC_B, SEVENSEG
;: DIGIT1, DIGIT2, DIGIT3, DIGIT4
;----------------------------------------------
DOUT_4D
	clrwdt			;   .
	pagesel	DIGIT_CALC_B
	call	DIGIT_CALC_B	;    
	movf	HIGHD,W		;    W
	addlw	-01h		;  1, ,      0
	pagesel	dout_4d_s1
	btfss	STATUS,C	;  ,    
	goto	dout_4d_s1	
	movf	HIGHD,W		;      W
	pagesel	dout_4d_s2
	goto	dout_4d_s2
dout_4d_s1
	movlw	b'00000000'	;   
	movwf	DIGIT2		;     DIGIT2
	pagesel	dout_4d_s3
	goto	dout_4d_s3
dout_4d_s2
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT2		;      DIGIT2
dout_4d_s3
	movf	HIGHD,W		;    W
	addlw	-01h		;  1, ,      0
	pagesel	dout_4d_s4
	btfsc	STATUS,C	;   ,      
	goto	dout_4d_s4	
	movf	MIDDLED,W	;     W
	addlw	-01h		;  1, ,     0
	pagesel	dout_4d_w1
	btfss	STATUS,C	;  ,    
	goto	dout_4d_w1	
dout_4d_s4
	movf	MIDDLED,W	;      W
	pagesel	dout_4d_w2
	goto	dout_4d_w2
dout_4d_w1
	movlw	b'00000000'	;   
	movwf	DIGIT3		;     DIGIT3
	pagesel	dout_4d_w3
	goto	dout_4d_w3
dout_4d_w2
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT3		;      DIGIT3
dout_4d_w3
	movf	LOWD,W		;    W
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT4		;      DIGIT4
	movlw  	.0 
	movwf  	DIGIT1		;     DIGIT1
	return
;----------------------------------------------
;     
;: SETTINGS
;: 
;: DISPLAY_1, DISPLAY_2, DISPLAY_3, DOFF_ALL
;: 
;----------------------------------------------
DOUT_SET
	clrwdt			;   .
	pagesel	dout_set_e
	btfsc	SETTINGS,0	;   
	goto	dout_set_e	; SETTINGS,0 = 1,  
	pagesel	dout_set_clp
	btfsc	SETTINGS,1	;      
	goto	dout_set_clp	; SETTINGS,1 = 1,    
	pagesel	dout_set_no0
	btfsc	SETTINGS,2	;      0
	goto	dout_set_no0	; SETTINGS,2 = 1,    0
	pagesel	dout_set_no1
	btfsc	SETTINGS,3	;      1
	goto	dout_set_no1	; SETTINGS,3 = 1,    1
	pagesel	dout_set_no2
	btfsc	SETTINGS,4	;      2
	goto	dout_set_no2	; SETTINGS,4 = 1,    2
	pagesel	dout_set_no3
	btfsc	SETTINGS,5	;      3
	goto	dout_set_no3	; SETTINGS,5 = 1,    3
	pagesel	dout_set_no4
	btfsc	SETTINGS,6	;      4
	goto	dout_set_no4	; SETTINGS,6 = 1,    4
	pagesel	dout_set_no5
	btfsc	SETTINGS,7	;      5
	goto	dout_set_no5	; SETTINGS,7 = 1,    5
	pagesel	dout_set_no6
	btfsc	SETTINGS2,0	;      6
	goto	dout_set_no6	; SETTINGS2,0 = 1,    6
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_clp
	movlw  	.0
	movwf  	DIGIT4
	movlw	b'00110111' 
	movwf  	DIGIT3
	movlw	.102
	movwf  	DIGIT2
	movlw  	.0 
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;     2
	call	DISPLAY_2
;    
	movf	TIME_P,W	;      W
	movwf	CALCW		;     CALCW
	bcf	CALCW,7	
	movf	CALCW,W		;       W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	dout_set_clp_w4
	btfsc	TIME_P,7	;    
	goto	dout_set_clp_w4	; TIME_P,7 = 1,  
	pagesel	dout_set_clp_w5
	goto	dout_set_clp_w5	;
dout_set_clp_w4
	movlw  	b'01000000'
	movwf  	DIGIT1		;     DIGIT1
dout_set_clp_w5
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_no0
	movlw  	.63
	movwf  	DIGIT4
	movlw	.0 
	movwf  	DIGIT3
	movlw	b'00111111'
	movwf  	DIGIT2
	movlw  	b'01110110'
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;  HO 0   2
	call	DISPLAY_2
;   
	movf	OSV_0,W		;     W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_no1
	movlw  	.6
	movwf  	DIGIT4
	movlw	.0 
	movwf  	DIGIT3
	movlw	b'00111111'
	movwf  	DIGIT2
	movlw  	b'01110110'
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;  HO 1   2
	call	DISPLAY_2
;   
	movf	OSV_1,W		;     W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_no2
	movlw  	.91
	movwf  	DIGIT4
	movlw	.0 
	movwf  	DIGIT3
	movlw	b'00111111'
	movwf  	DIGIT2
	movlw  	b'01110110'
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;  HO 1   2
	call	DISPLAY_2
;   
	movf	OSV_2,W		;     W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_no3
	movlw  	.79
	movwf  	DIGIT4
	movlw	.0 
	movwf  	DIGIT3
	movlw	b'00111111'
	movwf  	DIGIT2
	movlw  	b'01110110'
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;  HO 1   2
	call	DISPLAY_2
;   
	movf	OSV_3,W		;     W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_no4
	movlw  	.102
	movwf  	DIGIT4
	movlw	.0 
	movwf  	DIGIT3
	movlw	b'00111111'
	movwf  	DIGIT2
	movlw  	b'01110110'
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;  HO 1   2
	call	DISPLAY_2
;   
	movf	OSV_4,W		;     W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_no5
	movlw  	.109
	movwf  	DIGIT4
	movlw	.0 
	movwf  	DIGIT3
	movlw	b'00111111'
	movwf  	DIGIT2
	movlw  	b'01110110'
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;  HO 1   2
	call	DISPLAY_2
;   
	movf	OSV_5,W		;     W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_no6
	movlw  	.125
	movwf  	DIGIT4
	movlw	.0 
	movwf  	DIGIT3
	movlw	b'00111111'
	movwf  	DIGIT2
	movlw  	b'01110110'
	movwf  	DIGIT1
	pagesel	DISPLAY_2	;  HO 1   2
	call	DISPLAY_2
;   
	movf	OSV_6,W		;     W
	pagesel	DOUT_4D	
	call	DOUT_4D		;      
	pagesel	DISPLAY_3	;  
	call	DISPLAY_3
	pagesel	dout_set_e
	goto	dout_set_e
dout_set_e
	return