;      ST2416
;    
;TIME_P		;  
;OSV_0		;  
;OSV_1
;OSV_2
;OSV_3
;OSV_4
;OSV_5
;OSV_6

;----------------------------------------------
;    
;: TIME_P, OSV_0, OSV_1, OSV_2, OSV_3, OSV_4, OSV_5, OSV_6, OSV_7
;: W
;: I2C_START_T, I2C_BYTE_T, I2C_STOP_T
;: 
;----------------------------------------------
FLASH_WRITE
	clrwdt			;   .
	pagesel	I2C_START_T
	call	I2C_START_T	;   ""
	movlw	ADRES_FLASH_W	;     
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movlw	ADRES_FLASH	;     
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	TIME_P,W	;   W TIME_P
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	OSV_0,W		;   W OSV_0
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	OSV_1,W		;   W OSV_1
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	OSV_2,W		;   W OSV_2
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	OSV_3,W		;   W OSV_3
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	OSV_4,W		;   W OSV_4
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	OSV_5,W		;   W OSV_5
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	movf	OSV_6,W		;   W OSV_6
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	pagesel	I2C_STOP_T
	call	I2C_STOP_T	;   "" 
	return
;----------------------------------------------
;    
;: 		
;: W, 
;: I2C_START_T, I2C_BYTE_T, I2C_BYTE_R, , I2C_STOP_T
;: TIME_P, OSV_0, OSV_1, OSV_2, OSV_3, OSV_4, OSV_5, OSV_6, OSV_7
;----------------------------------------------
FLASH_READ
	clrwdt			;   .
	pagesel	I2C_START_T
	call	I2C_START_T	;   ""
	movlw	ADRES_FLASH_W	;     
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	movlw	ADRES_FLASH	;     
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;   
	pagesel	I2C_START_T
	call	I2C_START_T	;  
	movlw	ADRES_FLASH_R	;     
	movwf	BTR		;   I2C
	pagesel	I2C_BYTE_T
	call	I2C_BYTE_T	;      
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   TIME_P  
	movf	BTR,W		;     I2C
	movwf	TIME_P		;   
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   OSV_0  
	movf	BTR,W		;     I2C
	movwf	OSV_0		;   
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   OSV_1  
	movf	BTR,W		;     I2C
	movwf	OSV_1		;   
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   OSV_2  
	movf	BTR,W		;     I2C
	movwf	OSV_2		;   
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   OSV_3  
	movf	BTR,W		;     I2C
	movwf	OSV_3		;   
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   OSV_4  
	movf	BTR,W		;     I2C
	movwf	OSV_4		;   
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   OSV_5  
	movf	BTR,W		;     I2C
	movwf	OSV_5		;   
	pagesel	I2C_BYTE_R
	call	I2C_BYTE_R	;   OSV_6  
	movf	BTR,W		;     I2C
	movwf	OSV_6		;   
	pagesel	I2C_STOP_T
	call	I2C_STOP_T	;   "" 
	return