;    GPS

;----------------------------------------------
;      GPS (GPVTG   GPZDA )
;$GPVTG  VTG      (COG)     (SOG). 
;$GPZDA  ZDA      UTC,  , ,     . 
;: 	
;: FSR, W, SETTINGS2, 
;: 
;: SETTINGS2, GPS_10H, GPS_01H, GPS_10M, GPS_01M, GPS_10S, GPS_01S, GPS_10_D, GPS_01_D, GPS_10_M, GPS_01_M,
; GPS_10Y, GPS_01Y, GPS_01_S, GPS_10_S, GPS_100_S
;----------------------------------------------
GPS_ALL
	clrwdt				;   .
	pagesel	gps_all_ex
	btfss	BUTTONS,3		;    
	goto	gps_all_ex		; BUTTONS,3 = 0,   ,    
gps_all_1
	movlw	data_gps		;      
	movwf	FSR
	incf	FSR,f			;  2
	incf	FSR,f			;  3
	movlw	0x5A			;       "Z"
	xorwf	INDF,W			;
	pagesel	gps_all_dt
	btfsc	STATUS,Z	
	goto	gps_all_dt		;  , 
	movlw	0x56			;       "V"
	xorwf	INDF,W			;
	pagesel	gps_all_v
	btfsc	STATUS,Z	
	goto	gps_all_v		;  ,  
	pagesel	gps_all_ex
	goto	gps_all_ex		;   ,    
gps_all_dt
;	pagesel	gps_all_ex
	btfss	SETTINGS2,1		;    /  GPS
	goto	gps_all_ex		; SETTINGS2,1 = 0,    
;______________________________________________________________________________________________________
;  
gps_all_dt_f
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_dt_f
	btfss	STATUS,Z
	goto	gps_all_dt_f		;   , 
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_ex
	btfsc	STATUS,Z
	goto	gps_all_ex		;  ,    , 
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_10H			;   
	incf	FSR,f			;    
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_01H			;   
	incf	FSR,f			;    
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_10M			;   
	incf	FSR,f			;    
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_01M			;   
	incf	FSR,f			;    
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_10S			;   
	incf	FSR,f			;    
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_01S			;    
; 
gps_all_dt_f1
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_dt_f1
	btfss	STATUS,Z
	goto	gps_all_dt_f1		;   , 
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_ex
	btfsc	STATUS,Z
	goto	gps_all_ex		;  ,    , 
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_10_D		;   
	incf	FSR,f			;    
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_01_D		;   
gps_all_dt_f2
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_dt_f2
	btfss	STATUS,Z
	goto	gps_all_dt_f2		;   , 
; 
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_ex
	btfsc	STATUS,Z
	goto	gps_all_ex		;  ,    , 
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_10_M		;   
	incf	FSR,f			;    
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_01_M		;   
; 
gps_all_dt_f3
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_dt_f3
	btfss	STATUS,Z
	goto	gps_all_dt_f3		;   , 
	incf	FSR,f			;    ,    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_ex
	btfsc	STATUS,Z
	goto	gps_all_ex		;  ,    , 
	incf	FSR,f			;    ,  , 
	incf	FSR,f			;
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_10Y			;   
	incf	FSR,f			;
	movf	INDF,W			;      W
	addlw	-0x30			;   
	movwf	GPS_01Y			;   
; 
	bsf	SETTINGS2,2		;    /  GPS
	bcf	SETTINGS2,1		;    /  GPS
	pagesel	gps_all_ex
	goto	gps_all_ex		;    
;______________________________________________________________________________________________________
;   
gps_all_v
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_v
	btfss	STATUS,Z		;  1- ?
	goto	gps_all_v		;   , 
gps_all_v2
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_v2
	btfss	STATUS,Z		;  2- ?
	goto	gps_all_v2		;   , 
gps_all_v3
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_v3
	btfss	STATUS,Z		;  3- ?
	goto	gps_all_v3		;   , 
gps_all_v4
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_v4
	btfss	STATUS,Z		;  4- ?
	goto	gps_all_v4		;   , 
gps_all_v5
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_v5
	btfss	STATUS,Z		;  5- ?
	goto	gps_all_v5		;   , 
gps_all_v6
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_v6
	btfss	STATUS,Z		;  6- ?
	goto	gps_all_v6		;   , 
gps_all_v7
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_v7
	btfss	STATUS,Z		;  7- ?
	goto	gps_all_v7		;   , 
gps_all_v70
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_ex
	btfsc	STATUS,Z		;   ?
	goto	gps_all_ex		;  ,     , 
gps_all_v8
	incf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_ex
	btfsc	STATUS,Z
	goto	gps_all_ex		;  ,  , 
	movlw	0x2E			;        "."
	xorwf	INDF,W			;
	pagesel	gps_all_v9
	btfsc	STATUS,Z
	goto	gps_all_v9		;  , 
	pagesel	gps_all_v8
	goto	gps_all_v8
gps_all_v9
	decf	FSR,f			;    
	movf	INDF,W			;     W
	addlw	-0x30			;   
	movwf	GPS_01_S		;   
	decf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_vv_01
	btfsc	STATUS,Z
	goto	gps_all_vv_01		;  ",", , 1  
	movf	INDF,W			;     W
	addlw	-0x30			;   
	movwf	GPS_10_S		;   
	decf	FSR,f			;    
	movlw	0x2C			;        ","
	xorwf	INDF,W			;
	pagesel	gps_all_vv_10
	btfsc	STATUS,Z
	goto	gps_all_vv_10		;  ",", , 2  
	movf	INDF,W			;     W
	addlw	-0x30			;   
	movwf	GPS_100_S		;   
	pagesel	gps_all_vv_100		;
	goto	gps_all_vv_100		; , 3  
gps_all_vv_01
	clrf	GPS_10_S		;   
	clrf	GPS_100_S		;   
	pagesel	gps_all_vv_100
	goto	gps_all_vv_100
gps_all_vv_10
	clrf	GPS_100_S		;   
	pagesel	gps_all_vv_100
	goto	gps_all_vv_100
gps_all_vv_100
	bsf	SETTINGS2,3		;      GPS
	pagesel	gps_all_ex
	goto	gps_all_ex		;    
gps_all_ex
	bcf	CALC_I,0		;     GPS 
	return
