;        
;----------------------------------------------
;    /  GPS
;: 	
;: SETTINGS2, 
;: 
;: SETTINGS2,1
;----------------------------------------------
FZDT
	movlw	b'00000000'		;    0  
	xorwf	Minute,W		;
	pagesel	fzdt_e
	btfss	STATUS,Z
	goto	fzdt_e			;  0 , 
	bsf	SETTINGS2,1		;    /  GPS
fzdt_e
	return
;----------------------------------------------
;         RTC
;: 	GPS_10H, GPS_01H, GPS_10M, GPS_01M, GPS_10S, GPS_01S, GPS_10_D, GPS_01_D, GPS_10_M, GPS_01_M,
; GPS_10Y, GPS_01Y
;: CorrS, CALCW, LOWD, rezLH
;: DIGIT_CALC_B, MUL_1x1
;: Hour, Minute, Second, Day, Month, Year
;----------------------------------------------
DT_CALC
	clrwdt				;   .
	pagesel	dt_calc_e
	btfss	SETTINGS2,2		;    /  GPS
	goto	dt_calc_e		; SETTINGS2,2 = 0,  
	bsf	CorrS,0			;      
;  
	movf	GPS_10H,W		;     W
	movwf	LOWD			;    LOWD
	movlw	.10			; 
	movwf	CALCW			;    CALCW
	pagesel	MUL_1x1
	call	MUL_1x1			; ,    LOWD
	movf	GPS_01H,W		;     W
	addwf	LOWD,f			;   LOWD
	movf	LOWD,W			;
	movwf	rezLH			;       rezLH  dt_calc_t
;   
	movf	TIME_P,W		;      W
	movwf	CALCW			;     CALCW
	bcf	CALCW,7			;      CALCW
;    
	pagesel	dt_calc_p
	btfss	TIME_P,7		;    
	goto	dt_calc_p
	pagesel	dt_calc_m
	goto	dt_calc_m
dt_calc_p
	movf	CALCW,w			;    W
	addwf	LOWD,f			;  
	movlw	.233
	addwf	LOWD,W			; ,   W
	pagesel	dt_calc_ex
	btfsc	STATUS,C		;   
	goto	dt_calc_ex		; , 
	pagesel	dt_calc_s
	goto	dt_calc_s
dt_calc_m
	movf	CALCW,w	
	subwf	LOWD,f			;  
	pagesel	dt_calc_ex
	btfsc	STATUS,C		;   
	goto	dt_calc_ex		; , 
dt_calc_s
	movf	LOWD,w	
	pagesel	DIGIT_CALC_B	
	call	DIGIT_CALC_B		;    ,   MIDDLED,   LOWD
	swapf	MIDDLED,W		;    MIDDLED    W
	addwf	LOWD,W			;   
	movwf	Hour			;   
;  
	swapf	GPS_10M,W		;    GPS_10M    W
	addwf	GPS_01M,W		;   
	movwf	Minute			;   
;   
	swapf	GPS_10S,W		;    GPS_10S    W
	addwf	GPS_01S,W		;   
	movwf	Second			;   
dt_calc_t
	movlw	.11			;  11 ?
	xorwf	rezLH,W			;      
	pagesel	dt_calc_z
	btfss	STATUS,Z
	goto	dt_calc_z		;  11 ,   
;    
	swapf	GPS_10_D,W		;    GPS_10_D    W
	addwf	GPS_01_D,W		;   
	movwf	Day			;   
;    
	swapf	GPS_10_M,W		;    GPS_10_M    W
	addwf	GPS_01_M,W		;   
	movwf	Month			;   
;    
	swapf	GPS_10Y,W		;    GPS_10_Y    W
	addwf	GPS_01Y,W		;   
	movwf	Year			;   
dt_calc_z
	pagesel	RTC_WRITE	
	call	RTC_WRITE		;   RTC
dt_calc_ex
	bcf	CorrS,0			;      
	bcf	CorrS,7			;     
	bcf	SETTINGS2,2		;    /  GPS 
dt_calc_e
	return
;----------------------------------------------
;     
;: 	
;: W
;: DT_OUT_T, DT_OUT_D
;: 
;----------------------------------------------
DT_OUT
	clrwdt			;   .
;    
	pagesel	dt_out_1
	btfss	BUTTONS,4	;    
	goto	dt_out_1	; ,  
	pagesel	DT_OUT_D	;  
	call	DT_OUT_D	;  
	pagesel	dt_out_e
	goto	dt_out_e
dt_out_1
	pagesel	DT_OUT_T
	call	DT_OUT_T	;  
dt_out_e
	return
;----------------------------------------------
;       
;: Hour, Minute, Second, 	
;: W
;: DIGIT_CALC_H, DIGIT_DATA, DIGIT_CALC_SMD
;: DIGIT13-DIGIT43
;----------------------------------------------
DT_OUT_T
	clrwdt			;   .
;   
	movf	Hour,W		;    W
	pagesel	DIGIT_CALC_H
	call	DIGIT_CALC_H	;    		
	movf	HIGHD,W		;     W
	addlw	-01h		;  1, ,      0
	pagesel	dt_out_t_w1
	btfss	STATUS,C	;  ,    
	goto	dt_out_t_w1	
	movf	HIGHD,W		;       W
	pagesel	dt_out_t_w2
	goto	dt_out_t_w2
dt_out_t_w1
	movlw	b'00000000'	;   
	movwf	DIGIT1		;     DIGIT1
	pagesel	dt_out_t_w3
	goto	dt_out_t_w3
dt_out_t_w2
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT1		;       DIGIT1
dt_out_t_w3
	movf	LOWD,W		;     W
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT2		;       DIGIT2
	pagesel	dt_out_t_w4
	btfss	Second,0	;   
	goto	dt_out_t_w4	;  
	bsf	DIGIT2,7	;  
dt_out_t_w4
	movf	Minute,W	;    W
	pagesel	DIGIT_CALC_SMD
	call	DIGIT_CALC_SMD	;    		
	movf	HIGHD,W		;     W
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT3		;       DIGIT3
	movf	LOWD,W		;     W
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT4		;       DIGIT4
	return
;----------------------------------------------
;      
;:  Day, Month, Year	
;: W
;: DIGIT_CALC_H, DIGIT_DATA, DIGIT_CALC_SMD
;: DIGIT13-DIGIT43
;----------------------------------------------
DT_OUT_D
	clrwdt			;   .
;  
	movf	Day,W		;    W
	pagesel	DIGIT_CALC_SMD
	call	DIGIT_CALC_SMD	;    		
	movf	HIGHD,W		;     W
	addlw	-01h		;  1, ,      0
	pagesel	dt_out_t_w1
	btfss	STATUS,C	;  ,    
	goto	dt_out_d_w1	
	movf	HIGHD,W		;       W
	pagesel	dt_out_d_w2
	goto	dt_out_d_w2
dt_out_d_w1
	movlw	b'00000000'	;   
	movwf	DIGIT1		;     DIGIT1
	pagesel	dt_out_d_w3
	goto	dt_out_d_w3
dt_out_d_w2
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT1		;       DIGIT1
dt_out_d_w3
	movf	LOWD,W		;     W
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT2		;       DIGIT2
	movf	Month,W		;    W
	pagesel	DIGIT_CALC_SMD
	call	DIGIT_CALC_SMD	;    		
	movf	HIGHD,W		;     W
	addlw	-01h		;  1, ,      0
	pagesel	dt_out_t_w4
	btfss	STATUS,C	;  ,    
	goto	dt_out_d_w4	
	movf	HIGHD,W		;       W
	pagesel	dt_out_d_w5
	goto	dt_out_d_w5
dt_out_d_w4
	movlw	b'00000000'	;   
	movwf	DIGIT3		;     DIGIT3
	pagesel	dt_out_d_w6
	goto	dt_out_d_w6
dt_out_d_w5
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT3		;       DIGIT3
dt_out_d_w6
	movf	LOWD,W		;     W
	pagesel	SEVENSEG	;    
	call	SEVENSEG
	movwf	DIGIT4		;       DIGIT4
	return

